# Generated by Django 4.2.7 on 2023-11-01 12:00

from django.conf import settings
import django.contrib.postgres.fields
import django.core.serializers.json
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='CategoryAncestor',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('descendant_name', models.CharField(max_length=20)),
                ('depth', models.SmallIntegerField()),
                ('ancestor_name', models.CharField(max_length=20)),
            ],
            options={
                'ordering': ['descendant_name', '-depth'],
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='CategoryProp',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('category_name', models.CharField(max_length=20)),
                ('prop_fullname', models.CharField(max_length=255)),
                ('prop_category_name', models.CharField(max_length=20)),
                ('prop_name', models.CharField(max_length=20)),
                ('prop_parent_name', models.CharField(blank=True, max_length=20, null=True)),
                ('prop_parent_fullname', models.CharField(blank=True, max_length=20, null=True)),
                ('prop_ordinal', models.SmallIntegerField(default=1000)),
                ('prop_nature', models.CharField(choices=[('T', 'Text'), ('I', 'Integer'), ('D', 'Decimal'), ('B', 'Boolean'), ('M', 'Datetime'), ('J', 'Date'), ('H', 'Time'), ('R', 'Relation'), ('S', 'Section'), ('A', 'Table'), ('C', 'Choices')], default='T', max_length=1)),
                ('prop_unit', models.CharField(blank=True, max_length=20, null=True)),
                ('prop_index', models.CharField(blank=True, max_length=10, null=True)),
                ('prop_index_with', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=20), blank=True, null=True, size=None)),
                ('prop_search', models.BooleanField(default=False)),
                ('prop_help', models.TextField(blank=True, max_length=255, null=True)),
            ],
            options={
                'ordering': ['category_name', models.OrderBy(models.F('prop_parent_fullname'), nulls_first=True), 'prop_ordinal', 'prop_fullname'],
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Report_Detail',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('at', models.DateTimeField(db_index=True, default=django.utils.timezone.now)),
                ('origin', models.CharField(choices=[('A', 'API'), ('C', 'Code'), ('M', 'Admin'), ('W', 'Web')], max_length=1)),
                ('item_count', models.BigIntegerField()),
                ('issue_count', models.BigIntegerField()),
                ('root_action', models.CharField(blank=True, choices=[('C', 'Create'), ('U', 'Update'), ('N', 'No change')], max_length=1, null=True)),
                ('root_data', models.JSONField(blank=True, encoder=django.core.serializers.json.DjangoJSONEncoder, null=True)),
                ('created', models.DateTimeField(auto_now_add=True)),
            ],
            options={
                'ordering': ['-at', '-id'],
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Category',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=20, unique=True, validators=[django.core.validators.RegexValidator('^[A-Z][a-zA-Z0-9]+$')])),
                ('slug', models.SlugField(max_length=20, unique=True)),
                ('help', models.CharField(blank=True, max_length=255, null=True)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('parent', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.RESTRICT, related_name='child_set', to='cmdbase.category')),
            ],
            options={
                'verbose_name_plural': 'categories',
                'ordering': ['name'],
            },
        ),
        migrations.CreateModel(
            name='IssueNature',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('value', models.CharField(max_length=255, unique=True)),
            ],
            options={
                'ordering': ['value'],
            },
        ),
        migrations.CreateModel(
            name='Item',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=255)),
                ('slug', models.SlugField(max_length=255)),
                ('data', models.JSONField(blank=True, encoder=django.core.serializers.json.DjangoJSONEncoder, null=True)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('category', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, related_name='items', to='cmdbase.category')),
                ('created_by', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('updated_by', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'ordering': ['name', 'category'],
            },
        ),
        migrations.CreateModel(
            name='Report',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('at', models.DateTimeField(db_index=True, default=django.utils.timezone.now)),
                ('origin', models.CharField(choices=[('A', 'API'), ('C', 'Code'), ('M', 'Admin'), ('W', 'Web')], max_length=1)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('by', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'ordering': ['-at', '-id'],
            },
        ),
        migrations.CreateModel(
            name='ReportItem',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('action', models.CharField(blank=True, choices=[('C', 'Create'), ('U', 'Update'), ('N', 'No change')], max_length=1, null=True)),
                ('path', models.CharField(blank=True, max_length=255, null=True)),
                ('data', models.JSONField(encoder=django.core.serializers.json.DjangoJSONEncoder)),
                ('item', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.RESTRICT, to='cmdbase.item')),
                ('report', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, related_name='reportitem_set', to='cmdbase.report')),
            ],
            options={
                'ordering': ['report', 'id'],
            },
        ),
        migrations.CreateModel(
            name='Relation',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('path', models.CharField(max_length=255)),
                ('source', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='targetrelation_set', to='cmdbase.item')),
                ('target', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='reverserelation_set', to='cmdbase.item')),
            ],
        ),
        migrations.CreateModel(
            name='Prop',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=20, validators=[django.core.validators.RegexValidator('^[a-z][a-z0-9_]+$')])),
                ('fullname', models.CharField(max_length=255)),
                ('ordinal', models.SmallIntegerField(default=1000)),
                ('nature', models.CharField(blank=True, choices=[('T', 'Text'), ('I', 'Integer'), ('D', 'Decimal'), ('B', 'Boolean'), ('M', 'Datetime'), ('J', 'Date'), ('H', 'Time'), ('R', 'Relation'), ('S', 'Section'), ('A', 'Table'), ('C', 'Choices')], max_length=1, null=True)),
                ('unit', models.CharField(blank=True, max_length=20, null=True)),
                ('index', models.CharField(blank=True, max_length=10, null=True)),
                ('index_with', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=20), blank=True, null=True, size=None)),
                ('search', models.BooleanField(default=False)),
                ('help', models.CharField(blank=True, max_length=255, null=True)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('category', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='directprop_set', to='cmdbase.category')),
                ('parent', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.RESTRICT, related_name='child_set', to='cmdbase.prop')),
            ],
            options={
                'ordering': ['fullname', 'category'],
            },
        ),
        migrations.CreateModel(
            name='Issue',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('nature_args', models.JSONField(encoder=django.core.serializers.json.DjangoJSONEncoder)),
                ('on_id', models.PositiveIntegerField()),
                ('context', models.JSONField(blank=True, encoder=django.core.serializers.json.DjangoJSONEncoder, null=True)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('acked', models.DateTimeField(blank=True, null=True)),
                ('acked_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.RESTRICT, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('nature', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to='cmdbase.issuenature')),
                ('on_type', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to='contenttypes.contenttype')),
            ],
            options={
                'ordering': ['nature'],
            },
        ),
        migrations.AddConstraint(
            model_name='reportitem',
            constraint=models.UniqueConstraint(condition=models.Q(('path__isnull', True)), fields=('report', 'item'), name='unique_report_root_item'),
        ),
        migrations.AddConstraint(
            model_name='reportitem',
            constraint=models.CheckConstraint(check=models.Q(models.Q(('action__isnull', False), ('item__isnull', False)), ('path__isnull', True), _connector='OR'), name='item_and_action_required_if_not_root_path'),
        ),
        migrations.AlterUniqueTogether(
            name='relation',
            unique_together={('source', 'path')},
        ),
        migrations.AlterUniqueTogether(
            name='prop',
            unique_together={('category', 'parent', 'name'), ('category', 'fullname')},
        ),
        migrations.AlterUniqueTogether(
            name='item',
            unique_together={('category', 'name'), ('category', 'slug')},
        ),
        migrations.AddIndex(
            model_name='issue',
            index=models.Index(fields=['on_type', 'on_id'], name='cmdbase_iss_on_type_4358a6_idx'),
        ),
        migrations.AlterUniqueTogether(
            name='issue',
            unique_together={('nature', 'nature_args', 'on_type', 'on_id')},
        ),
        migrations.AddConstraint(
            model_name='category',
            constraint=models.CheckConstraint(check=models.Q(('parent__isnull', False), ('name', 'Item'), _connector='OR'), name='only_root_item_has_no_parent'),
        ),
    ]
